unit IDKSMdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TIDKSMDialog = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    HelpBtn: TButton;
    Edit1: TEdit;
    SearchButton: TButton;
    ListBox1: TListBox;
    GoButton: TButton;
    CancelButton: TButton;
    Bevel2: TBevel;
    Label3: TLabel;
    hitCount: TLabel;
    procedure HelpBtnClick(Sender: TObject);
    procedure SearchButtonClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    nameList : TStringList;
    hitTotal : integer;
    baseDir : string;
  public
    { Public declarations }
  end;

var
  IDKSMDialog: TIDKSMDialog;

implementation

{$R *.DFM}

uses Main, IDKSM;

procedure TIDKSMDialog.HelpBtnClick(Sender: TObject);
begin
//   Calls help however you want to do it
end;


// The following procedure is the meat of how to call the
// IDKSM Search Engine. The rest you can modify to your
// hearts content.

procedure TIDKSMDialog.SearchButtonClick(Sender: TObject);
var
   Engine : TIDKSM;
   hitList : PChar;
   nameListPtr : PChar;
begin
   ListBox1.Clear;
   nameList.Clear;
   GoButton.Enabled := False;

// Create the engine
   Engine := TIDKSM.Create(baseDir + 'sample');

// This call does all the work and fills out the lists
   Engine.FindWords(Edit1.Text);

// This moves the data from the engine to the local list
   hitList := Engine.hitList.GetText;
   ListBox1.Items.SetText(hitList);
   ListBox1.ItemIndex := -1;   {nothing selected for default}
   StrDispose(hitList);

// Should be obvious
   hittotal := Engine.hitTotal;
   hitCount.Caption := Format('%d', [hitTotal]);
   if hitTotal > 0 then
   begin
// Only if hits exist copy the files path and name list
// to a local list for processing.
      nameListPtr := Engine.nameList.GetText;
      nameList.SetText(nameListPtr);
      StrDispose(nameListPtr);
   end;

// Since all of the engine data has been moved to a local
// list the engine can be disposed off.
   Engine.Free;
end;

procedure TIDKSMDialog.Edit1Change(Sender: TObject);
begin
   if Length(Edit1.Text) > 0 then
      SearchButton.Enabled := True
   else
      SearchButton.Enabled := False;
end;

procedure TIDKSMDialog.ListBox1Click(Sender: TObject);
begin
   if hitTotal > 0 then
      GoButton.Enabled := True;
end;

procedure TIDKSMDialog.ListBox1DblClick(Sender: TObject);
begin
   if hitTotal > 0 then
      GoButton.Enabled := True;

// Pass file path and name stored in Database
   SampleForm.ShowHTMLFile(nameList[ListBox1.ItemIndex]);
end;

procedure TIDKSMDialog.FormCreate(Sender: TObject);
begin
   nameList := TStringList.Create;

// need this so you know where to find database
   baseDir := SampleForm.GetBase;
end;

procedure TIDKSMDialog.FormDestroy(Sender: TObject);
begin
   nameList.Free;
end;

procedure TIDKSMDialog.GoButtonClick(Sender: TObject);
begin
// Pass file path and name stored in Database
   SampleForm.ShowHTMLFile(nameList[ListBox1.ItemIndex]);
end;

procedure TIDKSMDialog.FormShow(Sender: TObject);
begin

// Only enables the search button if search words entered
   if Length(Edit1.Text) > 0 then
      SearchButton.Enabled := True
   else
      SearchButton.Enabled := False;
end;

end.

